"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GwasAssociationStudyTrait(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "ontologies": opencb_2_9_3.OntologyTermAnnotation,
            "scores": opencb_2_9_3.GwasAssociationStudyTraitScores,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.OntologyTermAnnotation": opencb_2_9_3.OntologyTermAnnotation,
            "org.opencb.biodata.models.variant.avro.GwasAssociationStudyTraitScores": opencb_2_9_3.GwasAssociationStudyTraitScores,
            "org.opencb.biodata.models.variant.avro.GwasAssociationStudyTrait": opencb_2_9_3.GwasAssociationStudyTrait,
        }

    __slots__ = [
        "diseaseTrait",
        "ontologies",
        "scores",
        "strongestSnpRiskAllele",
    ]

    def __init__(
        self,
        diseaseTrait=None,
        ontologies=None,
        scores=None,
        strongestSnpRiskAllele=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.GwasAssociationStudyTrait model.

        :param diseaseTrait:
        :type diseaseTrait: None | str
        :param ontologies:
        :type ontologies: None | list[OntologyTermAnnotation]
        :param scores:
        :type scores: None | list[GwasAssociationStudyTraitScores]
        :param strongestSnpRiskAllele:
        :type strongestSnpRiskAllele: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
